CONFIG -= qt
CONFIG += console

win32-msvc*:QMAKE_CXXFLAGS = -WX
win32-msvc*:DEFINES += _CRT_SECURE_NO_WARNINGS _SCL_SECURE_NO_WARNINGS

# CONFIG supports "c++14" starting with Qt 5.4, but it does not pass -std=c++14 to clang,
# so don't use it.
# Simply pass -std=c++1y and hope for the best
clang|gcc {
    QMAKE_CXXFLAGS += -std=c++1y
}

# Make sure to link against libc++ from clang, not libstdc++ from GCC.
# libc++ is more complete, and trying to use libstdc++ with clang gives me an
# error:
#     cstdio:119:11: error: no member named 'gets' in the global namespace
clang {
    QMAKE_CXXFLAGS+=-stdlib=libc++
    QMAKE_LFLAGS+=-stdlib=libc++
    QMAKE_LIBS+=-lc++abi
}

