#include <vector>
#include <iostream>
#include <iterator>
#include <algorithm>
#include <string>
#include <initializer_list>

using namespace std;

// Yes, this class is not exception safe. Sue me.
template<typename T>
class MyVector
{
public:
    MyVector(initializer_list<T> values)
    {
        m_data = reinterpret_cast<T*>(malloc(sizeof(T) * values.size()));
        m_count = values.size();
        std::uninitialized_copy(values.begin(), values.end(), m_data);

        //for (auto it = values.begin(); it != values.end(); ++it)
        //    cout << *it << endl;
    }

    ~MyVector()
    {
        for (size_t i = 0; i < m_count; i++) {
            m_data[i].~T();
        }
        free(m_data);
    }

    void printElements() const
    {
        for (size_t i = 0; i < m_count; i++) {
            std::cout << i << ": " << m_data[i] << endl;
        }
    }

private:
    // Don't bother with copying and moving in this example
    MyVector(const MyVector &) = delete;
    MyVector(MyVector &&) = delete;

    T *m_data;
    size_t m_count;
};

int main()
{
    MyVector<int> vec = { 1, 3, 5, 7, 11, 13 };
    vec.printElements();

    return 0;
}
