#include <iostream>
#include <chrono>

using namespace std;
using namespace std::chrono;

unsigned long long fibonacci(unsigned long long n)
{
    if (n <= 2)
        return 1;
    else
        return fibonacci(n - 1) + fibonacci(n - 2);
}

int main()
{
    const time_point<system_clock> now = system_clock::now();
    const hours hoursSinceEpoch =
      duration_cast<hours>(now.time_since_epoch());
    cout << "Hours since start of epoch: "
         << hoursSinceEpoch.count() << endl;

    time_t nowTime = system_clock::to_time_t(now);
       cout << "Now: " << ctime(&nowTime);

    const high_resolution_clock::time_point before = high_resolution_clock::now();
    fibonacci(41);
    const high_resolution_clock::time_point after = high_resolution_clock::now();

    typedef duration<float, ratio<60 * 45,1>> schoolhours;

    // Pity rand() is not constexpr :)
    //typedef duration<float, ratio<rand() % 60,1>> minuteInProgressDialog;

    auto executionDuration = after - before;
    milliseconds ms = duration_cast<milliseconds>(executionDuration);
    nanoseconds ns = executionDuration;
    schoolhours sh = executionDuration; // no duration_cast needed - representation is float
    cout << "Calculating fibonacci(41) took:" << endl;
    cout << "   " << ms.count() << " ms" << endl;
    cout << "   " << ns.count() << " ns" << endl;
    cout << "   " << sh.count() << " school hours" << endl;

    return 0;
}
