#include <iostream>
#include <limits>

class Point
{
    int m_x, m_y;
public:
    constexpr Point(int x, int y)
        : m_x{x}, m_y{y}
    {}

    constexpr int x() const { return m_x; }
    constexpr int y() const { return m_y; }

    constexpr void multiply(int scalar)
    {
        m_x *= scalar;
        m_y *= scalar;
    }
};

constexpr int calc(int start, int iterations, int factor)
{
    Point a{12, start};
    for (int i = 0; i < iterations; i++) {
        if (a.x() < 20000)
            a.multiply(factor);
        else
            a = Point{start, 12};
    }
    return a.x() * a.y();
}

template<typename T>
constexpr T min(std::initializer_list<T> input)
{
    T min = std::numeric_limits<T>::max();
    for (T x : input)
        if (x < min)
            min = x;
    return min;
}

static_assert(calc(4, 3, 7) == 5647152, "Incorrect calculation");
static_assert(min({4, 8, 15, 16, 23, 42}) == 4, "Incorrect calculation");

int main(int , char *[])
{
    std::cout << calc(4, 3, 7) << std::endl;
    std::cout << min({4, 8, 15, 16, 23, 42}) << std::endl;
}
