#include <iostream>

using namespace std;

class Point
{
public:
    constexpr Point(int x, int y)
        : m_x{x}, m_y{y}
    {
    }

    constexpr Point mirrored() const
    {
        return Point{-m_x, -m_y};
    }

    void print() const
    {
        cout << m_x << ',' << m_y << endl;
    }

private:
    int m_x;
    int m_y;
};

constexpr Point points[] = {
    {0, 0},
    {2, 4},
    {1, -3},
    {0, 1},
    {-10, -3},
    {3, 7}
};


int main()
{
    for (const Point &p : points)
        p.print();

    constexpr Point p1{12, 42};
    constexpr Point p2 = p1.mirrored();
    p2.print();
    return 0;
};
