#include <iostream>
#include <vector>
#include <type_traits>

using namespace std;

template<class T>
class HasIterator
{
    struct Yes {};
    struct No {};

    template<class U>
    static Yes test(typename U::iterator *it);

    template<class U>
    static No test(...);

public:
    static const bool value = is_same<decltype(test<T>(0)), Yes>::value;
};

template<class T>
void print(const T& containerToPrint,
           typename enable_if<HasIterator<T>::value, void>::type * = nullptr)
{
    int i = 0;
    for (const auto& value : containerToPrint) {
        cout << i++ << ": " << value << endl;
    }
}

template<class T>
void print(const T& valueToPrint,
           typename enable_if< ! HasIterator<T>::value>::type * = nullptr)
{
    cout << valueToPrint << endl;
}

int main()
{
    const vector<int> container{5, 6, 2, 6, 1};
    const int number = 42;
    print(container);
    print(number);
}
