#include <utility>
#include <cstdlib>

template <typename T>
class Explicit {
    T t;
public:
    Explicit() {}
    explicit Explicit(T t) : t{std::move(t)} {}
    operator T() const { return t; }
};

Explicit<bool> func() { return Explicit<bool>{true}; }

int main() {
    //const bool b = func();     // ERROR: cannot convert Explicit<bool> to const bool
    //const int i = 10 + func(); // ERROR:
    const bool b{ func() };      // OK
    (void)b;
    if ( func() ) {}             // OK
    return func() ? EXIT_SUCCESS : EXIT_FAILURE ; // OK
}
