#include <iostream>
#include <algorithm>

template<typename Iterator>
void printRange(Iterator begin, Iterator end)
{
    std::cout << "-----------------------------\n";

    std::for_each(begin, end, [count = 0](const auto &element) mutable {
        std::cout << count << ": " << element << std::endl;
        count++;
    });

    std::cout << "-----------------------------\n\n";
}

int main(int , char *[])
{
    auto strings = { "Hello", "From", "Berlin", "!"};
    auto ints = {1, 3, 6, 10, 15, 21, 28, 36, 45};
    printRange(cbegin(strings), cend(strings));
    printRange(cbegin(ints), cend(ints));
    return 0;
}
