#include <cstddef>
#include <iostream>

// Example how nullptr was emulated in C++98
const class {
public:
  template <typename T>
  operator T*() const { return 0; }
  template <typename C, typename R>
  operator R C::*() const { return 0; }
private:
  void operator&() const; // deleted
} NULLPTR = {};

void f(int)   { std::cout << "f(int)"   << std::endl; }
void f(char*) { std::cout << "f(char*)" << std::endl; }

int main() {
    f(0);                  // OK, calls f(int)
    //f(NULL);             // might call f(int) or be ambiguous
    //f(0L);               // ambiguous (typical NULL define)
    //f((void*)0);         // ambiguous (typical NULL define)
    f(nullptr);            // OK, calls f(char*);
    f(NULLPTR);            // OK, calls f(char*);
}
