#include <functional>
#include <vector>
#include <iostream>

using namespace std;
using namespace std::placeholders;

void incrementBy(int &value, int amount)
{
    value += amount;
}

int main()
{
    int value = 10;
    incrementBy(value, 12);
    cout << "Value: " << value << endl;

    { // Broken
        auto incrementValue = bind(incrementBy, value, _1);
        incrementValue(42);
        cout << "Value: " << value << endl;
    }

    auto incrementValue = bind(incrementBy, ref(value), _1);
    incrementValue(42);
    cout << "Value: " << value << endl;

    // Does not even compile
    //vector<int&> intRefVector;

    vector<reference_wrapper<int>> intRefVector;
    intRefVector.push_back(ref(value));
    incrementBy(intRefVector.front(), 10);
    cout << "Value: " << value << endl;
}

