SOURCES += regex.cpp

# GCC 4.8 and smaller do not support regular expressions, so use boost
# instead.
# No need to check this on Windows VS can handle it.
unix {
    greaterThan(QT_GCC_MAJOR_VERSION, 4)|greaterThan(QT_GCC_MINOR_VERSION, 8)  {
        message("GCC version without regular expression support, trying to use boost::regex instead.")
        # Find Boost library.
        _BOOST_ROOT = $$(BOOST_ROOT)
        isEmpty(_BOOST_ROOT) {
            message(\"Boost Library\" environment variable not detected...)
            message(Please set the environment variable `BOOST_ROOT`. For example: export BOOST_ROOT=/usr/lib/x86_64-linux-gnu/)
            message(Skipping ex-regex examples. Needs boost-regex lib or GCC version >= 4.9)
        } else {
            INCLUDEPATH += $$(_BOOST_ROOT)
            LIBS += -lboost_regex
            DEFINES += USE_BOOST
        }
    }
}

include(../../config.pri)
