#include <iostream>
#include <cassert>

//
// String is a small wrapper around const char*. It should be a literal
// type, i.e. have a constexpr constructor and a trivial destructor.
// The String does not assume ownership of the const char * it wraps, i.e.
// it will neither allocate nor deallocate memory. It will not copy the
// characters of the wrapped const char *, but simply point to them.
// std::experimental::string_view is very similar to this.
//
// TODO:
// * Uncomment the code in main() and createEmptyString() to test your
//   implementation
// * Implement the methods in the String class
// ** Add constexpr and const whenever possible
//
class String
{
public:
    // Should construct an empty string of length 0.
    String()
    {
    }

    // Should construct a String object from the given characters.
    String(const char */*data*/)
    {
    }

    // Should return the length of the string, excluding the terminating \0.
    int size()
    {
        return 42;
    }

    // Should return the amount of vowels in the string (a, e, i, o u and their
    // uppercase versions).
    int vowelCount()
    {
        return 42;
    }

    // Should clear the string, so that the result is an empty string.
    void clear()
    {
    }

    // Should output some details of the string using std::cout. Example output:
    // "Info for string 'Hello World! Adios!':
    //   size: 19
    //   vowels: 6"
    void dumpInfo()
    {
    }

    // Should return a pointer to the underlying character data.
    operator const char*()
    {
        return nullptr;
    }

    // Should return the character specified at the given index.
    // If the index is invalid, std::out_of_range should be thrown.
    char operator[](int /*index*/)
    {
        return 'X';
    }

private:
    // TODO
};

//
// The following code tests your String class in various ways.
// Uncomment the code, but don't modify it in any way.
//

/*
static constexpr String createEmptyString()
{
    String result("nonsense");
    result.clear();
    return result;
}
*/

int main()
{
    /*
    constexpr String helloWorld("Hello World! Adios!");
    static_assert(helloWorld.size() == 19, "size() broken!");
    static_assert(helloWorld.vowelCount() == 6, "vowelCount() broken!");
    static_assert(helloWorld[0] == 'H', "operator[] broken!");
    static_assert(helloWorld[4] == 'o', "operator[] broken!");
    try {
        helloWorld[4711];
        assert(false); // Unreachable
    } catch (const std::out_of_range &) {
    }
    helloWorld.dumpInfo();

    constexpr String test("constexpr is fast!");
    static_assert(test.size() == 18, "size() broken!");
    static_assert(test.vowelCount() == 4, "vowelCount() broken!");
    std::cout << test << std::endl;

    constexpr String null;
    static_assert(null.size() == 0, "size() broken!");
    static_assert(null.vowelCount() == 0, "vowelCount() broken!");

    constexpr String empty("");
    static_assert(empty.size() == 0, "size() broken!");
    static_assert(empty.vowelCount() == 0, "vowelCount() broken!");

    constexpr String empty2 = createEmptyString();
    static_assert(empty2.size() == 0, "size() broken!");
    static_assert(empty2.vowelCount() == 0, "vowelCount() broken!");

    constexpr int arraySize = 128;
    char randomChars[arraySize];
    randomChars[arraySize - 1] = 0;
    for (int i = 0; i < arraySize - 1; i++) {
        randomChars[i] = 'A' + rand() % 24;
    }
    const String random(randomChars);
    assert(random.size() == arraySize - 1);
    random.dumpInfo();
    */
}
