#ifndef SENSORDATA_H
#define SENSORDATA_H

class SensorData
{
public:
    SensorData(int timestamp, int temperature);

    int timestamp() const;
    int temperature() const;

private:
    /**
     * We mark the class as uncopyable here to enforce its usage via
     * pointers.
     * This emulates a more complex class that cannot be copied easily.
     */
    SensorData(const SensorData &other) = delete;
    void operator =(const SensorData &other) = delete;

    int m_timestamp;
    int m_temperature;
};

#endif // SENSORDATA_H
