TEMPLATE = subdirs
CONFIG -= ordered
SUBDIRS += \
        ex-binder-forward \
        ex-binder-overload \
        ex-chrono \
        ex-enable_if \
        ex-explicit-bool \
        ex-first-c++11-app \
        ex-forwarding \
        ex-functional \
        ex-local-and-unnamed-types \
        ex-nullptr \
        ex-unordered-map \
        ex-random \
        ex-reference-wrapper \
        ex-shared_ptr \
        ex-trivial \
        ex-tuple \
        lab-move-semantics \
        lab-processing-pipeline \
        lab-shared-pointer \
        lab-typededuction \
        lab-using-for-typedefs \
        lab-algorithms \
        sol-move-semantics \
        sol-processing-pipeline \
        sol-shared-pointer \
        sol-typededuction \
        sol-using-for-typedefs \
        sol-algorithms \

!win32-msvc*: SUBDIRS += ex-constexpr ex-exceptions

config_cpp14 {
    SUBDIRS += ex-variable-templates \
               ex-deprecated \
               ex-lambda-capture \
               ex-generic-lambda
}

config_cpp14-constexpr {
    SUBDIRS += ex-constexpr-relaxed \
               lab-constexpr \
               sol-constexpr \
}

# GCC 4.8 and smaller do not support regular expressions, so use boost
# instead.
# No need to check this on Windows, VS can handle it.
unix {
    greaterThan(QT_GCC_MAJOR_VERSION, 4)|greaterThan(QT_GCC_MINOR_VERSION, 8)  {
        message("GCC version without regular expression support, trying to use boost::regex instead.")
        # Find Boost library.
        _BOOST_ROOT = $$(BOOST_ROOT)
        isEmpty(_BOOST_ROOT) {
            message(\"Boost Library\" environment variable not detected...)
            message(Please set the environment variable `BOOST_ROOT`. For example: export BOOST_ROOT=/usr/lib/x86_64-linux-gnu/)
            message(Skipping ex-regex examples. Needs boost-regex lib or GCC version >= 4.9)
        } else {
           SUBDIRS += ex-regex
        }
    }
}
