#include <iostream>
#include <thread>
#include <mutex>

using namespace std;

mutex m;

bool isPrime(unsigned int n)
{
    if (n <= 1)
        return false;

    for (unsigned int i = 2; i < n; i++) {
        if (n % i == 0)
            return false;
    }

    return true;
}

unsigned long long fibonacci(unsigned long long n)
{
    if (n <= 2)
        return 1;
    else
        return fibonacci(n - 1) + fibonacci(n - 2);
}

void printPrime()
{
    // Make sure to lock after doing the expensive calculations, otherwise the
    // calculations can't run in parallel!
    const bool result1 = isPrime(1021);
    const bool result2 = isPrime(1023);

    m.lock();
    cout << "Prime check for 1021: " << result1 << endl;
    cout << "Prime check for 1023: " << result2 << endl;
    m.unlock();
}

void printFibonacci()
{
    const unsigned long long result = fibonacci(10);

    const lock_guard<mutex> guard{m};
    cout << "Fibonacci of 10: " << result << endl;
}

int main()
{
    thread t{printFibonacci};
    printPrime();
    t.join();
}
