#include <iostream>
#include <thread>

using namespace std;

bool isPrime(unsigned int n)
{
    if (n <= 1)
        return false;

    for (unsigned int i = 2; i < n; i++) {
        if (n % i == 0)
            return false;
    }

    return true;
}

unsigned long long fibonacci(unsigned long long n)
{
    if (n <= 2)
        return 1;
    else
        return fibonacci(n - 1) + fibonacci(n - 2);
}

void printPrime()
{
    cout << "Prime check for 1021: " << isPrime(1021) << endl;
    cout << "Prime check for 1023: " << isPrime(1023) << endl;
}

void printFibonacci()
{
    // Observe how changing the value to 10 triggers corrupted output, as
    // the outputs from printPrime() and printFibonacci() are mixed
    // together.
    // We are accessing shared memory (the cout stream) without syncronization!
    cout << "Fibonacci of 40: " << fibonacci(40) << endl;
}

int main()
{
    thread t{printFibonacci};

    // Observe how uncommenting these two lines below will cause a call to terminate,
    // as we are destroying t while it is still running
    printPrime();
    t.join();
}
