#include <iostream>
#include <list>
#include <functional>
#include <future>
#include <mutex>
#include <thread>

using namespace std;

//
// Please follow the steps and look at the README.txt file for more informations if needed.
//
// Overview of steps:
// Step 1: Start Calculator::run() in a secondary thread.
// Step 2: Add task queuing in createTask() and processing in run().
// Step 3: Use futures and promises to return the result to the caller.
// Step 4 (optional): Make the thread stopable and finish correctly.
//

using ulonglong = unsigned long long;

bool isPrime(ulonglong n)
{
    if (n <= 1)
        return false;

    for (ulonglong i = 2; i < n; i++) {
        if (n % i == 0)
            return false;
    }

    return true;
}

ulonglong nthPrime_impl(ulonglong n)
{
    ulonglong numPrimesFound = 0;
    for (ulonglong i = 1;; i++) {
        if (isPrime(i)) {
            numPrimesFound++;
            if (numPrimesFound == n)
                return i;
        }
    }
}

static ulonglong fib_impl(ulonglong n)
{
    if (n <= 2)
        return 1;
    else
        return fib_impl(n - 1) + fib_impl(n - 2);
}

class Calculator
{
public:
    void run();

    // TODO: Step 4 (optional): Add a stop() method

    future<ulonglong> nthPrime(ulonglong n);
    future<ulonglong> fib(ulonglong n);

private:
    future<ulonglong> createTask(ulonglong n,
                                 function<ulonglong(ulonglong)> func);

    struct Task {
        // TODO: Step 3: What else is needed here?

        function<ulonglong(ulonglong)> func;
        ulonglong input;
    };

    list<Task> m_tasks;
    // TODO: Step 2: What else is needed here?
    // TODO: Step 4 (optional): What else is needed here?
};

future<ulonglong> Calculator::createTask(
        ulonglong /*n*/, function<ulonglong(ulonglong)> /*func*/)
{
    // TODO: Step 2: Create a new task and put it into the task queue (m_tasks)
    //       The 'n' and 'func' parameters are needed, so uncomment
    //       them in the parameter list above.
    //       Don't bother with futures and promises yet.

    // TODO: Step 3: Return the future associated with the task. Remove the
    //               empty promise below and implement that properly

    // Just a stub, remove in step 3
    promise<ulonglong> p;
    return p.get_future();
}

future<ulonglong> Calculator::nthPrime(ulonglong n)
{
    return createTask(n, nthPrime_impl);
}

future<ulonglong> Calculator::fib(ulonglong n)
{
    return createTask(n, fib_impl);
}

void Calculator::run()
{
    // TODO: Step 1: Put debug output here to check if the function was started correctly.

    // TDOO: Step 2: Wait for new tasks to be added to the task queue (m_tasks), then process
    //               them. Do that in a loop to be able to process tasks that were enqueued later.
    //               Just print the result, don't bother with futures and promises yet.

    // TODO: Step 3: Remove debug printing of result, instead set result to the promise

    // TODO: Step 4 (optional): Return from the function if the cancel flag is set
}

int main()
{
    Calculator calc;

    // TODO: Step 1: Start calc's run method in a thread.

    auto prime = calc.nthPrime(5000);
    auto fib = calc.fib(41);

    // TODO: Step 3: Remove the sleep and instead uncomment the debug statements to check
    //               the results from the calculator
    this_thread::sleep_for(chrono::seconds(10));
    //cout << "The prime is: " << prime.get() << endl;
    //cout << "The fib is: " << fib.get() << endl;

    // TODO: Step 4 (optional): Stop the calculator and wait for it to finish.
}
