#include <iostream>
#include <chrono>
#include <cmath>
#include <string>

using namespace std;
using namespace std::chrono;

double calc1(int a, int b, float c)
{
    return a + b * sin(c) + rand();
}

double calc2(int a, int b, float c, const string &d)
{
    return a * a * a * d.length() / (b - sin(c)) + rand();
}

// Note: This should be using perfect forwarding, but we don't know about that
//       at this point yet.
template<typename Func, typename ... Args>
void benchmark(const std::string &test_name, int count, const Func &func,
               const Args& ...args)
{
    auto start_time = high_resolution_clock::now();
    for (int i = 0; i < count; i++) {
        func(args...);
    }
    auto elapsed = high_resolution_clock::now() - start_time;
    cout << R"(Test ")" << test_name << R"(" took )"
         << duration_cast<milliseconds>(elapsed).count() << "ms." << endl;
}

int main()
{
    benchmark("calc1", 9000000, calc1, 42, 10, 0.5f);
    benchmark("calc2", 10000000, calc2, 23, 12, 0.3f, "variadic!");
}
