#include <iostream>
#include <complex>
#include <typeinfo>
#include <type_traits>

using namespace std;

template<typename T>
void printTypeImpl()
{
    cout << "Name: " << typeid(T).name() << endl
         << "  Size: " << sizeof(T) << endl
         << "  Integral: " << boolalpha << is_integral<T>::value << endl;
    cout << endl;
}

template<typename First>
void printTypes()
{
    printTypeImpl<First>();
}

template<typename First, typename Second, typename ... Tail>
void printTypes()
{
    printTypeImpl<First>();
    printTypes<Second, Tail...>();
}

int main()
{
    printTypes<string, complex<float>, int, double*>();

    return 0;
}
