#include <algorithm>
#include <functional>
#include <iostream>
#include <numeric>
#include <string>
#include <vector>

using namespace std;

using ulonglong = unsigned long long;

static ostream &operator <<(ostream &stream, const vector<ulonglong> &values)
{
    string content = accumulate(begin(values), end(values), string(),
                                [] (const string &content, ulonglong value) {
                                    if (content.empty())
                                        return to_string(value);
                                    else
                                        return content + ", " + to_string(value);
                                });
    stream << "(" << content << ")";
    return stream;
}

static bool isPrime(ulonglong n)
{
    if (n <= 1)
        return false;

    for (ulonglong i = 2; i < n; i++) {
        if (n % i == 0)
            return false;
    }

    return true;
}

static ulonglong nthPrime(ulonglong n)
{
    ulonglong numPrimesFound = 0;
    for (ulonglong i = 1;; i++) {
        if (isPrime(i)) {
            numPrimesFound++;
            if (numPrimesFound == n)
                return i;
        }
    }
}

static ulonglong fib(ulonglong n)
{
    if (n <= 2)
        return 1;
    else
        return fib(n - 1) + fib(n - 2);
}

// TODO: Implement me!
vector<ulonglong> generator(...)
{
    return {};
}

int main()
{
    cout << generator(fib, 10, 11, 12, 13) << endl;
    cout << generator(nthPrime, 14, 15, 16, 17, 22) << endl;

    return 0;
}
