#include <tuple>
#include <utility>
#include <type_traits>

using namespace std;

template <typename T, typename S> struct join_tuples;

// std::tuple_cat, but as meta-function
template <typename... Ts, typename... Ss>
struct join_tuples<tuple<Ts...>, tuple<Ss...>>
{
    using type = tuple<Ts..., Ss...>;
};

template <typename T, typename S> struct multiply_with;

template <typename... Ts>
struct multiply_with<tuple<Ts...>,tuple<>>
{
    using type = tuple<>;
};

template <typename... Ts, typename S, typename... Ss>
struct multiply_with<tuple<Ts...>,tuple<S,Ss...>>
    : join_tuples<
         tuple< pair<Ts,S>... >,
         typename multiply_with<tuple<Ts...>,tuple<Ss...>>::type
      > {};

static_assert( is_same<
                   multiply_with<
                      tuple<int,long,long long>,
                      tuple<float,double,long double>
                   >::type,
                   tuple< pair<int,float>,       pair<long,float>,       pair<long long,float>,
                          pair<int,double>,      pair<long,double>,      pair<long long,double>,
                          pair<int,long double>, pair<long,long double>, pair<long long,long double> >
               >::value, "type mismatch" );
               

int main() { return 0; }
