#include <algorithm>
#include <functional>
#include <iostream>
#include <numeric>
#include <string>
#include <vector>

using namespace std;

using ulonglong = unsigned long long;

static ostream &operator <<(ostream &stream, const vector<ulonglong> &values)
{
    string content = accumulate(begin(values), end(values), string(),
                                [] (const string &content, ulonglong value) {
                                    if (content.empty())
                                        return to_string(value);
                                    else
                                        return content + ", " + to_string(value);
                                });
    stream << "(" << content << ")";
    return stream;
}

static bool isPrime(ulonglong n)
{
    if (n <= 1)
        return false;

    for (ulonglong i = 2; i < n; i++) {
        if (n % i == 0)
            return false;
    }

    return true;
}

static ulonglong nthPrime(ulonglong n)
{
    ulonglong numPrimesFound = 0;
    for (ulonglong i = 1;; i++) {
        if (isPrime(i)) {
            numPrimesFound++;
            if (numPrimesFound == n)
                return i;
        }
    }
}

static ulonglong fib(ulonglong n)
{
    if (n <= 2)
        return 1;
    else
        return fib(n - 1) + fib(n - 2);
}

void generator_helper(vector<ulonglong> &,
                      function<ulonglong(ulonglong)>)
{
}

template<class Input, class... Inputs>
void generator_helper(vector<ulonglong> &result,
                      function<ulonglong(ulonglong)> fun,
                      Input value, Inputs... values)
{
    const auto index = result.size() - sizeof...(values) - 1;
    result[index] = fun(value);
    generator_helper(result, fun, values...);
}

template<class... Inputs>
vector<ulonglong> generator(function<ulonglong(ulonglong)> fun,
                            Inputs... values)
{
    vector<ulonglong> result;
    result.resize(sizeof...(values));
    generator_helper(result, fun, values...);
    return result;
}

// Alternative solution, without recursion. Only works in this case because
// all Inputs have the same type.
/*
template<class... Inputs>
vector<ulonglong> generator(function<ulonglong(ulonglong)> fun,
                            Inputs... values)
{
    return { fun(values)... };
}
*/

int main()
{
    cout << generator(fib, 10, 11, 12, 13) << endl;
    cout << generator(nthPrime, 14, 15, 16, 17, 22) << endl;

    return 0;
}
